package stamp.peripheral.servo.pololu;
import stamp.core.*;
//import stamp.math.*;

public class pololu_msc3 {

  private Uart tx;

  public pololu_msc3(Uart tx) {
    this.tx = tx;
  }

  public void setParameters(int servo_num, int parameter_databyte) {
   send_five_bytes(servo_num,0x00,parameter_databyte,0x00);
  }

  public void setSpeed(int servo_num, int speed_databyte) {
   send_five_bytes(servo_num,0x01,speed_databyte,0x00);
  }

  public void setPosition_1(int servo_num, int position_databyte) {
   send_five_bytes(servo_num,0x02,position_databyte,0x00);
  }

  public void setPosition_2(int servo_num, int position_databyte_1, int position_databyte_2) {
   send_five_bytes(servo_num,0x03,position_databyte_1,position_databyte_2);
  }

  public void setPosition_abs(int servo_num, int position_databyte_1, int position_databyte_2) {
   send_five_bytes(servo_num,0x04,position_databyte_1,position_databyte_2);
  }

  public void setNeutral(int servo_num, int databyte_1, int databyte_2) {
   send_five_bytes(servo_num,0x05,databyte_1,databyte_2);
  }

  public void send_five_bytes(int servo_num, int command, int data_byte_1, int data_byte_2){
  tx.sendByte(0x80); //Synchronization...always 0x80
  tx.sendByte(0x01); //Device ID...0x01 for 8-servo controller
  tx.sendByte(command); //One of 0(SetParameters), 1(SetSpeed), 2(SetPosition using 1 byte), 3(SetPosition using 2 bytes), 4(SetPosition,Absolute using 2 bytes), 5(SetNeutral using 2 bytes)
  tx.sendByte(servo_num); //Servo number (0-7 default)
  tx.sendByte(data_byte_1);
  if (command>2)  tx.sendByte(data_byte_2);
  }

}