package stamp.peripheral.servo.pololu;
//import stamp.peripheral.servo.pololu.*;
import stamp.core.*;

public class pololu_msc_test4 {

    static Uart pololu_serial = new Uart(Uart.dirTransmit,CPU.pin0,Uart.dontInvert,Uart.speed4800,Uart.stop1);
    static pololu_msc3 boxfish = new pololu_msc3(pololu_serial); //single PSC board with 1 servo

    static void main() {

        System.out.println("Servo Test Program");

        while( !isButtonPressed(1) ) { // Check pin #1 for button closure
            // Do nothing in this loop.
            // We are waiting for the button to be pressed, once the button is pressed,
            // this loop should exit and it will resume.
        }

        System.out.println("Button pressed - Starting!");

        boxfish.setParameters(0x00,0x6f);       // Set Neutral Positions
        boxfish.setNeutral(0x00,0x1e,0x3d);
        boxfish.setParameters(0x02,0x6f);
        boxfish.setNeutral(0x02,0x1e,0x3d);
        boxfish.setParameters(0x01,0x6f);
        boxfish.setNeutral(0x01,0x1e,0x3d);
        boxfish.setParameters(0x03,0x6f);
        boxfish.setNeutral(0x03,0x1e,0x3d);
        boxfish.setParameters(0x04,0x6f);
        boxfish.setNeutral(0x04,0x1e,0x3d);

        CPU.delay(10500); //wait 1 second

        boxfish.setSpeed(0x04,0x00);          // Tail Fin speed setting

        System.out.println( "Initial setup complete");

        while ( !isButtonPressed(1) ) { // While the button is *not* pressed, continue through loop

            boxfish.setPosition_abs(0x00,0x38,0x17); //move servo to left at rate 7
            boxfish.setPosition_abs(0x01,0x17,0x38);
            boxfish.setPosition_abs(0x02,0x38,0x17);
            boxfish.setPosition_abs(0x03,0x38,0x17);
            boxfish.setPosition_abs(0x04,0x17,0x38);
            CPU.delay(3500);       //wait .3 second

            boxfish.setPosition_abs(0x00,0x17,0x38); //move servo to right at rate 7
            boxfish.setPosition_abs(0x01,0x38,0x17);
            boxfish.setPosition_abs(0x02,0x1e,0x3d);
            boxfish.setPosition_abs(0x03,0x1e,0x3d);
            boxfish.setPosition_abs(0x04,0x38,0x17);
            CPU.delay(3500);       //wait .3 second
        }

        System.out.println( "Button pressed - Finished!" );
    }


    /**
     * Will check 'the button' to see if it is pressed or not
     * @param pinNumber  The pin # we want to check to see if it is closed (button press)
     */
    private static boolean isButtonPressed( int pinNumber ) {
        return (CPU.readPin( CPU.pins[pinNumber] ) == false);
    }
}