package stamp.peripheral.servo.pololu;
import stamp.core.*;

public class pololu_msc_test6 {

    static Uart pololu_serial = new Uart(Uart.dirTransmit,CPU.pin0,Uart.dontInvert,Uart.speed4800,Uart.stop1);
    static pololu_msc3 boxfish = new pololu_msc3(pololu_serial); //single PSC board with 1 servo

    static int[] speedArray = { 20, 21, 22 };

    static byte[] leftServoPos = {  0x00, 0x38, 0x17,         // recovery stroke
                                  0x01, 0x17, 0x38,
                                  0x02, 0x17, 0x38,
                                  0x03, 0x38, 0x17,
                                  0x04, 0x38, 0x17 };

    static byte[] rightServoPos = { 0x00, 0x17, 0x38,         // power stroke
                                  0x01, 0x38, 0x17,
                                  0x02, 0x1e, 0x3d,
                                  0x03, 0x1e, 0x3d,
                                  0x04, 0x17, 0x38 };

    static void main() {

        System.out.println("Movement Test Program");

        System.out.println("Starting!");

        CPU.delay(10500); // wait 1 second

               // Set Neutral Positions
        boxfish.setParameters(0x00,0x6f);
        boxfish.setNeutral(0x00,0x17,0x38);
        boxfish.setParameters(0x02,0x6f);
        boxfish.setNeutral(0x02,0x17,0x38);
        boxfish.setParameters(0x01,0x6f);
        boxfish.setNeutral(0x01,0x17,0x38);
        boxfish.setParameters(0x03,0x6f);
        boxfish.setNeutral(0x03,0x17,0x38);
        boxfish.setParameters(0x04,0x6f);
        boxfish.setNeutral(0x04,0x17,0x38);

        boxfish.setSpeed(0x04,0x00);          // Tail Fin speed setting

        System.out.println( "Initial setup complete");

        CPU.delay(30500);  // wait 3 seconds

       // Sensor data input

        performActions();

    }

   private static void performActions() {     // Order of Actions

        while (true) { // While the button is *not* (logic) pressed, continue through loop

            for( int cnt = 0; cnt < 10; cnt++ ) {          // Count
                swimStraight();                           // Action
            }


           // for( int cnt = 0; cnt < 3; cnt++ ) {
          //      swimRight();
          //  }

         //   for(int cnt = 0; cnt < 3; cnt++) {
          //      swimStraight();
         ///   }

          //  for( int cnt = 0; cnt < 3; cnt++ ) {
         //       swimLeft();

        //    }

         //    for( int cnt = 0; cnt < 10; cnt++ ) {
        //        swimStraight();

       //    }
       //
        //     for (int cnt = 0; cnt <6; cnt++ ) {
      //          swimAboutFace();

        //    }


        }
    }

    // Swim Movements
    /**
     * Will make the fish swim straight
     */
    private static void swimStraight() {
      System.out.println("Swimming Straight");

       for( int cnt = 0; cnt < 2; cnt++ ) {

         int speed = speedArray[cnt];
         byte leftArg1 = leftServoPos[3*cnt+0];
         byte leftArg2 = leftServoPos[3*cnt+1];
         byte leftArg3 = leftServoPos[3*cnt+2];

         byte rightArg1 = rightServoPos[3*cnt+0];
         byte rightArg2 = rightServoPos[3*cnt+1];
         byte rightArg3 = rightServoPos[3*cnt+2];

         // Do your stuff with the positions/etc
       }

    }

    /**
     * Will turn the fish to the right
     */
    private static void swimRight() {
        System.out.println("Swimming Right");
            boxfish.setPosition_abs(0x00,0x17,0x38); //move servo to left at rate 7
            boxfish.setPosition_abs(0x01,0x17,0x38);
            boxfish.setPosition_abs(0x02,0x38,0x17);
            boxfish.setPosition_abs(0x03,0x38,0x17);
            boxfish.setPosition_abs(0x04,0x38,0x17);
                CPU.delay(3500);       //wait .3 second

            boxfish.setPosition_abs(0x00,0x38,0x17); //move servo to right at rate 7
            boxfish.setPosition_abs(0x01,0x38,0x17);
            boxfish.setPosition_abs(0x02,0x1e,0x3d);
            boxfish.setPosition_abs(0x03,0x1e,0x3d);
            boxfish.setPosition_abs(0x04,0x17,0x38);
                CPU.delay(3500);       //wait .3 second
    }

    /**
     * Will turn the fish to the left
     */
    private static void swimLeft() {
       System.out.println("Swimming Left");
            boxfish.setPosition_abs(0x00,0x38,0x17); //move servo to left at rate 7
            boxfish.setPosition_abs(0x01,0x38,0x17);
            boxfish.setPosition_abs(0x02,0x17,0x38);
            boxfish.setPosition_abs(0x03,0x17,0x38);
            boxfish.setPosition_abs(0x04,0x38,0x17);
                CPU.delay(3500);       //wait .3 second

            boxfish.setPosition_abs(0x00,0x17,0x38); //move servo to right at rate 7
            boxfish.setPosition_abs(0x01,0x17,0x38);
            boxfish.setPosition_abs(0x02,0x1e,0x3d);
            boxfish.setPosition_abs(0x03,0x1e,0x3d);
            boxfish.setPosition_abs(0x04,0x17,0x38);
                CPU.delay(3500);       //wait .3 second
    }

    /**
     * Will turn the fish 'left about face'
     */
    private static void swimAboutFace() {
        System.out.println("Swimming About Face");
            boxfish.setPosition_abs(0x00,0x38,0x17); //move servo to left at rate 7
            boxfish.setPosition_abs(0x01,0x38,0x17);
            boxfish.setPosition_abs(0x02,0x17,0x38);
            boxfish.setPosition_abs(0x03,0x17,0x38);
            boxfish.setPosition_abs(0x04,0x1f,0x40);
                CPU.delay(3500);       //wait .3 second

            boxfish.setPosition_abs(0x00,0x17,0x38); //move servo to right at rate 7
            boxfish.setPosition_abs(0x01,0x17,0x38);
            boxfish.setPosition_abs(0x02,0x1e,0x3d);
            boxfish.setPosition_abs(0x03,0x1e,0x3d);
            boxfish.setPosition_abs(0x04,0x40,0x1f);
                CPU.delay(3500);      //wait .3 second
    }

//    private static void swimUp () {  }

//    private static void swimDown () { }


}