package stamp.peripheral.servo.pololu;
import stamp.core.*;

public class pololu_msc_test7 {

    static Uart pololu_serial = new Uart(Uart.dirTransmit,CPU.pin0,Uart.dontInvert,Uart.speed4800,Uart.stop1);
    static pololu_msc3 boxfish = new pololu_msc3(pololu_serial); //single PSC board with 1 servo

    static void main() {

        System.out.println("Starting!");

        CPU.delay(10500); // wait 1 second

        boxfish.setParameters(0x00,0x6f);       // Set Parameters and Neutral Positions
        boxfish.setNeutral(0x00,0x1e,0x3d);
        boxfish.setParameters(0x02,0x6f);
        boxfish.setNeutral(0x02,0x1e,0x3d);
        boxfish.setParameters(0x01,0x6f);
        boxfish.setNeutral(0x01,0x1e,0x3d);
        boxfish.setParameters(0x03,0x6f);
        boxfish.setNeutral(0x03,0x1e,0x3d);
        boxfish.setParameters(0x04,0x6f);
        boxfish.setNeutral(0x04,0x1e,0x3d);

        System.out.println( "Initial setup complete");

        CPU.delay(30500);  // wait 3 seconds

        performActions();

    }

    private static void performActions() {     // Order of Actions

        while (true) { // While the button is *not* (logic) pressed, continue through loop

            for( int cnt = 0; cnt < 10; cnt++ ) {          // Count
                swimStraight();                           // Action
            }

        //    for( int cnt = 0; cnt < 3; cnt++ ) {
        //       swimRight();
        //     }

        //  for(int cnt = 0; cnt < 6; cnt++) {
        //        swimStraight();
        //    }

        //    for( int cnt = 0; cnt < 3; cnt++ ) {
        //        swimLeft();

        //    }

        }
    }

    // Swim Movements
    /**
     * Will make the fish swim straight
     */
    private static void swimStraight() {
        System.out.println("Swimming Straight");      //speed setting?
            boxfish.setPosition_abs(0x00,0x38,0x17); //move side fins forward to horizontal position: Recovery Stroke
            boxfish.setPosition_abs(0x01,0x17,0x38);
            boxfish.setPosition_abs(0x02,0x17,0x38);
            boxfish.setPosition_abs(0x03,0x38,0x17);

         //   boxfish.setSpeed(0x04,0x05);           // Tail Fin settings
            boxfish.setPosition_abs(0x04,0x38,0x17);

                 CPU.delay(3500);

             boxfish.setPosition_abs(0x00,0x17,0x38); //move side fins to rear position: Power stroke
             boxfish.setPosition_abs(0x01,0x38,0x17);
             boxfish.setPosition_abs(0x02,0x1e,0x3d);
             boxfish.setPosition_abs(0x03,0x1e,0x3d);

          //   boxfish.setSpeed(0x04,0x05);           // Tail Fin settings
             boxfish.setPosition_abs(0x04,0x17,0x38);

                  CPU.delay(3500);
    }

    /**
     * Will turn the fish to the right
     */
    private static void swimRight() {
        System.out.println("Swimming Right");
            boxfish.setPosition_abs(0x00,0x17,0x38); //move servo to left at rate 7
            boxfish.setPosition_abs(0x01,0x17,0x38);
            boxfish.setPosition_abs(0x02,0x38,0x17);
            boxfish.setPosition_abs(0x03,0x38,0x17);
            boxfish.setPosition_abs(0x04,0x38,0x17);
                CPU.delay(3500);       //wait .3 second

            boxfish.setPosition_abs(0x00,0x38,0x17); //move servo to right at rate 7
            boxfish.setPosition_abs(0x01,0x38,0x17);
            boxfish.setPosition_abs(0x02,0x1e,0x3d);
            boxfish.setPosition_abs(0x03,0x1e,0x3d);
            boxfish.setPosition_abs(0x04,0x17,0x38);
                CPU.delay(3500);       //wait .3 second
    }

    /**
     * Will turn the fish to the left
     */
    private static void swimLeft() {
       System.out.println("Swimming Left");
            boxfish.setPosition_abs(0x00,0x38,0x17); //move servo to left at rate 7
            boxfish.setPosition_abs(0x01,0x38,0x17);
            boxfish.setPosition_abs(0x02,0x17,0x38);
            boxfish.setPosition_abs(0x03,0x17,0x38);
            boxfish.setPosition_abs(0x04,0x38,0x17);
                CPU.delay(3500);       //wait .3 second

            boxfish.setPosition_abs(0x00,0x17,0x38); //move servo to right at rate 7
            boxfish.setPosition_abs(0x01,0x17,0x38);
            boxfish.setPosition_abs(0x02,0x1e,0x3d);
            boxfish.setPosition_abs(0x03,0x1e,0x3d);
            boxfish.setPosition_abs(0x04,0x17,0x38);
                CPU.delay(3500);       //wait .3 second
    }

    /**
     * Will turn the fish 'left about face'
     */
    private static void swimAboutFace() {
        System.out.println("Swimming About Face");
            boxfish.setPosition_abs(0x00,0x38,0x17); //move servo to left at rate 7
            boxfish.setPosition_abs(0x01,0x38,0x17);
            boxfish.setPosition_abs(0x02,0x17,0x38);
            boxfish.setPosition_abs(0x03,0x17,0x38);
            boxfish.setPosition_abs(0x04,0x1f,0x40);
                CPU.delay(3500);       //wait .3 second

            boxfish.setPosition_abs(0x00,0x17,0x38); //move servo to right at rate 7
            boxfish.setPosition_abs(0x01,0x17,0x38);
            boxfish.setPosition_abs(0x02,0x1e,0x3d);
            boxfish.setPosition_abs(0x03,0x1e,0x3d);
            boxfish.setPosition_abs(0x04,0x40,0x1f);
                CPU.delay(3500);      //wait .3 second
    }


}